QCPFinancial Class Reference
Author: Emanuel Eichhammer

· · · ·
Public Types | Public Functions | Static Public Functions | Protected Functions
QCPFinancial Class Reference

A plottable representing a financial stock chart. More...

Inheritance diagram for QCPFinancial:

## Public Types
enum | ChartStyle

## Public Functions
| QCPFinancial (QCPAxis *keyAxis, QCPAxis *valueAxis)
QCPFinancialDataMap * | data () const
ChartStyle | chartStyle () const
double | width () const
bool | twoColored () const
QBrush | brushPositive () const
QBrush | brushNegative () const
QPen | penPositive () const
QPen | penNegative () const
void | setData (QCPFinancialDataMap *data, bool copy=false)
void | setData (const QVector< double > &key, const QVector< double > &open, const QVector< double > &high, const QVector< double > &low, const QVector< double > &close)
void | setChartStyle (ChartStyle style)
void | setWidth (double width)
void | setTwoColored (bool twoColored)
void | setBrushPositive (const QBrush &brush)
void | setBrushNegative (const QBrush &brush)
void | setPenPositive (const QPen &pen)
void | setPenNegative (const QPen &pen)
void | addData (const QCPFinancialDataMap &dataMap)
void | addData (const QCPFinancialData &data)
void | addData (double key, double open, double high, double low, double close)
void | addData (const QVector< double > &key, const QVector< double > &open, const QVector< double > &high, const QVector< double > &low, const QVector< double > &close)
void | removeDataBefore (double key)
void | removeDataAfter (double key)
void | removeData (double fromKey, double toKey)
void | removeData (double key)
virtual void | clearData ()
virtual double | selectTest (const QPointF &pos, bool onlySelectable, QVariant *details=0) const
Public Functions inherited from QCPAbstractPlottable
| QCPAbstractPlottable (QCPAxis *keyAxis, QCPAxis *valueAxis)
QString | name () const
bool | antialiasedFill () const
bool | antialiasedScatters () const
bool | antialiasedErrorBars () const
QPen | pen () const
QPen | selectedPen () const
QBrush | brush () const
QBrush | selectedBrush () const
QCPAxis * | keyAxis () const
QCPAxis * | valueAxis () const
bool | selectable () const
bool | selected () const
void | setName (const QString &name)
void | setAntialiasedFill (bool enabled)
void | setAntialiasedScatters (bool enabled)
void | setAntialiasedErrorBars (bool enabled)
void | setPen (const QPen &pen)
void | setSelectedPen (const QPen &pen)
void | setBrush (const QBrush &brush)
void | setSelectedBrush (const QBrush &brush)
void | setKeyAxis (QCPAxis *axis)
void | setValueAxis (QCPAxis *axis)
Q_SLOT void | setSelectable (bool selectable)
Q_SLOT void | setSelected (bool selected)
virtual bool | addToLegend ()
virtual bool | removeFromLegend () const
void | rescaleAxes (bool onlyEnlarge=false) const
void | rescaleKeyAxis (bool onlyEnlarge=false) const
void | rescaleValueAxis (bool onlyEnlarge=false) const
Public Functions inherited from QCPLayerable
| QCPLayerable (QCustomPlot *plot, QString targetLayer=QString(), QCPLayerable *parentLayerable=0)
bool | visible () const
QCustomPlot * | parentPlot () const
QCPLayerable * | parentLayerable () const
QCPLayer * | layer () const
bool | antialiased () const
void | setVisible (bool on)
Q_SLOT bool | setLayer (QCPLayer *layer)
bool | setLayer (const QString &layerName)
void | setAntialiased (bool enabled)
bool | realVisibility () const

## Static Public Functions
static QCPFinancialDataMap | timeSeriesToOhlc (const QVector< double > &time, const QVector< double > &value, double timeBinSize, double timeBinOffset=0)

## Protected Functions
virtual void | draw (QCPPainter *painter)
virtual void | drawLegendIcon (QCPPainter *painter, const QRectF &rect) const
virtual QCPRange | getKeyRange (bool &foundRange, SignDomain inSignDomain=sdBoth) const
virtual QCPRange | getValueRange (bool &foundRange, SignDomain inSignDomain=sdBoth) const
void | drawOhlcPlot (QCPPainter *painter, const QCPFinancialDataMap::const_iterator &begin, const QCPFinancialDataMap::const_iterator &end)
void | drawCandlestickPlot (QCPPainter *painter, const QCPFinancialDataMap::const_iterator &begin, const QCPFinancialDataMap::const_iterator &end)
double | ohlcSelectTest (const QPointF &pos, const QCPFinancialDataMap::const_iterator &begin, const QCPFinancialDataMap::const_iterator &end) const
double | candlestickSelectTest (const QPointF &pos, const QCPFinancialDataMap::const_iterator &begin, const QCPFinancialDataMap::const_iterator &end) const
void | getVisibleDataBounds (QCPFinancialDataMap::const_iterator &lower, QCPFinancialDataMap::const_iterator &upper) const
Protected Functions inherited from QCPAbstractPlottable
virtual QRect | clipRect () const
virtual QCP::Interaction | selectionCategory () const
void | applyDefaultAntialiasingHint (QCPPainter *painter) const
virtual void | selectEvent (QMouseEvent *event, bool additive, const QVariant &details, bool *selectionStateChanged)
virtual void | deselectEvent (bool *selectionStateChanged)
void | coordsToPixels (double key, double value, double &x, double &y) const
const QPointF | coordsToPixels (double key, double value) const
void | pixelsToCoords (double x, double y, double &key, double &value) const
void | pixelsToCoords (const QPointF &pixelPos, double &key, double &value) const
QPen | mainPen () const
QBrush | mainBrush () const
void | applyFillAntialiasingHint (QCPPainter *painter) const
void | applyScattersAntialiasingHint (QCPPainter *painter) const
void | applyErrorBarsAntialiasingHint (QCPPainter *painter) const
double | distSqrToLine (const QPointF &start, const QPointF &end, const QPointF &point) const
Protected Functions inherited from QCPLayerable
virtual void | parentPlotInitialized (QCustomPlot *parentPlot)
void | initializeParentPlot (QCustomPlot *parentPlot)
void | setParentLayerable (QCPLayerable *parentLayerable)
bool | moveToLayer (QCPLayer *layer, bool prepend)
void | applyAntialiasingHint (QCPPainter *painter, bool localAntialiased, QCP::AntialiasedElement overrideElement) const

## Additional Inherited Members
Signals inherited from QCPAbstractPlottable
void | selectionChanged (bool selected)
void | selectableChanged (bool selectable)
Signals inherited from QCPLayerable
void | layerChanged (QCPLayer *newLayer)
Protected Types inherited from QCPAbstractPlottable
enum | SignDomain

## Detailed Description

A plottable representing a financial stock chart.

This plottable represents time series data binned to certain intervals, mainly used for stock charts. The two common representations OHLC (Open-High-Low-Close) bars and Candlesticks can be set via setChartStyle.

The data is passed via setData as a set of open/high/low/close values at certain keys (typically times). This means the data must be already binned appropriately. If data is only available as a series of values (e.g. price against time), you can use the static convenience function timeSeriesToOhlc to generate binned OHLC-data which can then be passed to setData.

The width of the OHLC bars/candlesticks can be controlled with setWidth and is given in plot key coordinates. A typical choice is to set it to (or slightly less than) one bin interval width.

# Changing the appearance

Charts can be either single- or two-colored (setTwoColored). If set to be single-colored, lines are drawn with the plottable's pen (setPen) and fills with the brush (setBrush).

If set to two-colored, positive changes of the value during an interval (close >= open) are represented with a different pen and brush than negative changes (close < open). These can be configured with setPenPositive, setPenNegative, setBrushPositive, and setBrushNegative. In two-colored mode, the normal plottable pen/brush is ignored. Upon selection however, the normal selected pen/brush (setSelectedPen, setSelectedBrush) is used, irrespective of whether the chart is single- or two-colored.

## Member Enumeration Documentation

enum QCPFinancial::ChartStyle

Defines the possible representations of OHLC data in the plot.

See Also
  setChartStyle

Enumerator
csOhlc | Open-High-Low-Close bar representation.
csCandlestick | Candlestick representation.

## Constructor & Destructor Documentation

QCPFinancial::QCPFinancial | ( | QCPAxis * | keyAxis,
|  | QCPAxis * | valueAxis
| ) |  |
| explicit

Constructs a financial chart which uses keyAxis as its key axis ("x") and valueAxis as its value axis ("y"). keyAxis and valueAxis must reside in the same QCustomPlot instance and not have the same orientation. If either of these restrictions is violated, a corresponding message is printed to the debug output (qDebug), the construction is not aborted, though.

The constructed QCPFinancial can be added to the plot with QCustomPlot::addPlottable, QCustomPlot then takes ownership of the financial chart.

## Member Function Documentation

QCPFinancialDataMap * QCPFinancial::data | ( |  | ) | const
| inline

Returns a pointer to the internal data storage of type QCPFinancialDataMap. You may use it to directly manipulate the data, which may be more convenient and faster than using the regular setData or addData methods, in certain situations.

void QCPFinancial::setData | ( | QCPFinancialDataMap * | data,
|  | bool | copy = `false`
| ) |  |

Replaces the current data with the provided data.

If copy is set to true, data points in data will only be copied. if false, the plottable takes ownership of the passed data and replaces the internal data pointer with it. This is significantly faster than copying for large datasets.

Alternatively, you can also access and modify the plottable's data via the data method, which returns a pointer to the internal QCPFinancialDataMap.

See Also
  timeSeriesToOhlc

void QCPFinancial::setData | ( | const QVector< double > & | key,
|  | const QVector< double > & | open,
|  | const QVector< double > & | high,
|  | const QVector< double > & | low,
|  | const QVector< double > & | close
| ) |  |

This is an overloaded function.

Replaces the current data with the provided open/high/low/close data. The provided vectors should have equal length. Else, the number of added points will be the size of the smallest vector.

See Also
  timeSeriesToOhlc

void QCPFinancial::setChartStyle | ( | QCPFinancial::ChartStyle | style | ) |

Sets which representation style shall be used to display the OHLC data.

void QCPFinancial::setWidth | ( | double | width | ) |

Sets the width of the individual bars/candlesticks to width in plot key coordinates.

A typical choice is to set it to (or slightly less than) one bin interval width.

void QCPFinancial::setTwoColored | ( | bool | twoColored | ) |

Sets whether this chart shall contrast positive from negative trends per data point by using two separate colors to draw the respective bars/candlesticks.

If twoColored is false, the normal plottable's pen and brush are used (setPen, setBrush).

See Also
  setPenPositive, setPenNegative, setBrushPositive, setBrushNegative

void QCPFinancial::setBrushPositive | ( | const QBrush & | brush | ) |

If setTwoColored is set to true, this function controls the brush that is used to draw fills of data points with a positive trend (i.e. bars/candlesticks with close >= open).

If twoColored is false, the normal plottable's pen and brush are used (setPen, setBrush).

See Also
  setBrushNegative, setPenPositive, setPenNegative

void QCPFinancial::setBrushNegative | ( | const QBrush & | brush | ) |

If setTwoColored is set to true, this function controls the brush that is used to draw fills of data points with a negative trend (i.e. bars/candlesticks with close < open).

If twoColored is false, the normal plottable's pen and brush are used (setPen, setBrush).

See Also
  setBrushPositive, setPenNegative, setPenPositive

void QCPFinancial::setPenPositive | ( | const QPen & | pen | ) |

If setTwoColored is set to true, this function controls the pen that is used to draw outlines of data points with a positive trend (i.e. bars/candlesticks with close >= open).

If twoColored is false, the normal plottable's pen and brush are used (setPen, setBrush).

See Also
  setPenNegative, setBrushPositive, setBrushNegative

void QCPFinancial::setPenNegative | ( | const QPen & | pen | ) |

If setTwoColored is set to true, this function controls the pen that is used to draw outlines of data points with a negative trend (i.e. bars/candlesticks with close < open).

If twoColored is false, the normal plottable's pen and brush are used (setPen, setBrush).

See Also
  setPenPositive, setBrushNegative, setBrushPositive

void QCPFinancial::addData | ( | const QCPFinancialDataMap & | dataMap | ) |

Adds the provided data points in dataMap to the current data.

Alternatively, you can also access and modify the data via the data method, which returns a pointer to the internal QCPFinancialDataMap.

See Also
  removeData

void QCPFinancial::addData | ( | const QCPFinancialData & | data | ) |

This is an overloaded function.

Adds the provided single data point in data to the current data.

Alternatively, you can also access and modify the data via the data method, which returns a pointer to the internal QCPFinancialData.

See Also
  removeData

void QCPFinancial::addData | ( | double | key,
|  | double | open,
|  | double | high,
|  | double | low,
|  | double | close
| ) |  |

This is an overloaded function.

Adds the provided single data point given by key, open, high, low, and close to the current data.

Alternatively, you can also access and modify the data via the data method, which returns a pointer to the internal QCPFinancialData.

See Also
  removeData

void QCPFinancial::addData | ( | const QVector< double > & | key,
|  | const QVector< double > & | open,
|  | const QVector< double > & | high,
|  | const QVector< double > & | low,
|  | const QVector< double > & | close
| ) |  |

This is an overloaded function.

Adds the provided open/high/low/close data to the current data.

Alternatively, you can also access and modify the data via the data method, which returns a pointer to the internal QCPFinancialData.

See Also
  removeData

void QCPFinancial::removeDataBefore | ( | double | key | ) |

Removes all data points with keys smaller than key.

See Also
  addData, clearData

void QCPFinancial::removeDataAfter | ( | double | key | ) |

Removes all data points with keys greater than key.

See Also
  addData, clearData

void QCPFinancial::removeData | ( | double | fromKey,
|  | double | toKey
| ) |  |

Removes all data points with keys between fromKey and toKey. if fromKey is greater or equal to toKey, the function does nothing. To remove a single data point with known key, use removeData(double key).

See Also
  addData, clearData

void QCPFinancial::removeData | ( | double | key | ) |

This is an overloaded function.

Removes a single data point at key. If the position is not known with absolute precision, consider using removeData(double fromKey, double toKey) with a small fuzziness interval around the suspected position, depeding on the precision with which the key is known.

See Also
  addData, clearData

void QCPFinancial::clearData | ( |  | ) |
| virtual

Removes all data points.

See Also
  removeData, removeDataAfter, removeDataBefore

Implements QCPAbstractPlottable.

double QCPFinancial::selectTest | ( | const QPointF & | pos,
|  | bool | onlySelectable,
|  | QVariant * | details = `0`
| ) |  | const
| virtual

This function is used to decide whether a click hits a layerable object or not.

pos is a point in pixel coordinates on the QCustomPlot surface. This function returns the shortest pixel distance of this point to the object. If the object is either invisible or the distance couldn't be determined, -1.0 is returned. Further, if onlySelectable is true and the object is not selectable, -1.0 is returned, too.

If the object is represented not by single lines but by an area like a QCPItemText or the bars of a QCPBars plottable, a click inside the area should also be considered a hit. In these cases this function thus returns a constant value greater zero but still below the parent plot's selection tolerance. (typically the selectionTolerance multiplied by 0.99).

Providing a constant value for area objects allows selecting line objects even when they are obscured by such area objects, by clicking close to the lines (i.e. closer than 0.99*selectionTolerance).

The actual setting of the selection state is not done by this function. This is handled by the parent QCustomPlot when the mouseReleaseEvent occurs, and the finally selected object is notified via the selectEvent/deselectEvent methods.

details is an optional output parameter. Every layerable subclass may place any information in details. This information will be passed to selectEvent when the parent QCustomPlot decides on the basis of this selectTest call, that the object was successfully selected. The subsequent call to selectEvent will carry the details. This is useful for multi-part objects (like QCPAxis). This way, a possibly complex calculation to decide which part was clicked is only done once in selectTest. The result (i.e. the actually clicked part) can then be placed in details. So in the subsequent selectEvent, the decision which part was selected doesn't have to be done a second time for a single selection operation.

You may pass 0 as details to indicate that you are not interested in those selection details.

See Also
  selectEvent, deselectEvent, QCustomPlot::setInteractions

Implements QCPAbstractPlottable.

QCPFinancialDataMap QCPFinancial::timeSeriesToOhlc | ( | const QVector< double > & | time,
|  | const QVector< double > & | value,
|  | double | timeBinSize,
|  | double | timeBinOffset = `0`
| ) |  |
| static

A convenience function that converts time series data (value against time) to OHLC binned data points. The return value can then be passed on to setData.

The size of the bins can be controlled with timeBinSize in the same units as time is given. For example, if the unit of time is seconds and single OHLC/Candlesticks should span an hour each, set timeBinSize to 3600.

timeBinOffset allows to control precisely at what time coordinate a bin should start. The value passed as timeBinOffset doesn't need to be in the range encompassed by the time keys. It merely defines the mathematical offset/phase of the bins that will be used to process the data.

void QCPFinancial::draw | ( | QCPPainter * | painter | ) |
| protectedvirtual

This function draws the layerable with the specified painter. It is only called by QCustomPlot, if the layerable is visible (setVisible).

Before this function is called, the painter's antialiasing state is set via applyDefaultAntialiasingHint, see the documentation there. Further, the clipping rectangle was set to clipRect.

Implements QCPAbstractPlottable.

void QCPFinancial::drawLegendIcon | ( | QCPPainter * | painter,
|  | const QRectF & | rect
| ) |  | const
| protectedvirtual

called by QCPLegend::draw (via QCPPlottableLegendItem::draw) to create a graphical representation of this plottable inside rect, next to the plottable name.

The passed painter has its cliprect set to rect, so painting outside of rect won't appear outside the legend icon border.

Implements QCPAbstractPlottable.

QCPRange QCPFinancial::getKeyRange | ( | bool & | foundRange,
|  | QCPAbstractPlottable::SignDomain | inSignDomain = `sdBoth`
| ) |  | const
| protectedvirtual

called by rescaleAxes functions to get the full data key bounds. For logarithmic plots, one can set inSignDomain to either sdNegative or sdPositive in order to restrict the returned range to that sign domain. E.g. when only negative range is wanted, set inSignDomain to sdNegative and all positive points will be ignored for range calculation. For no restriction, just set inSignDomain to sdBoth (default). foundRange is an output parameter that indicates whether a range could be found or not. If this is false, you shouldn't use the returned range (e.g. no points in data).

Note that foundRange is not the same as QCPRange::validRange, since the range returned by this function may have size zero, which wouldn't count as a valid range.

See Also
  rescaleAxes, getValueRange

Implements QCPAbstractPlottable.

QCPRange QCPFinancial::getValueRange | ( | bool & | foundRange,
|  | QCPAbstractPlottable::SignDomain | inSignDomain = `sdBoth`
| ) |  | const
| protectedvirtual

called by rescaleAxes functions to get the full data value bounds. For logarithmic plots, one can set inSignDomain to either sdNegative or sdPositive in order to restrict the returned range to that sign domain. E.g. when only negative range is wanted, set inSignDomain to sdNegative and all positive points will be ignored for range calculation. For no restriction, just set inSignDomain to sdBoth (default). foundRange is an output parameter that indicates whether a range could be found or not. If this is false, you shouldn't use the returned range (e.g. no points in data).

Note that foundRange is not the same as QCPRange::validRange, since the range returned by this function may have size zero, which wouldn't count as a valid range.

See Also
  rescaleAxes, getKeyRange

Implements QCPAbstractPlottable.

void QCPFinancial::drawOhlcPlot | ( | QCPPainter * | painter,
|  | const QCPFinancialDataMap::const_iterator & | begin,
|  | const QCPFinancialDataMap::const_iterator & | end
| ) |  |
| protected

Draws the data from begin to end as OHLC bars with the provided painter.

This method is a helper function for draw. It is used when the chart style is csOhlc.

void QCPFinancial::drawCandlestickPlot | ( | QCPPainter * | painter,
|  | const QCPFinancialDataMap::const_iterator & | begin,
|  | const QCPFinancialDataMap::const_iterator & | end
| ) |  |
| protected

Draws the data from begin to end as Candlesticks with the provided painter.

This method is a helper function for draw. It is used when the chart style is csCandlestick.

double QCPFinancial::ohlcSelectTest | ( | const QPointF & | pos,
|  | const QCPFinancialDataMap::const_iterator & | begin,
|  | const QCPFinancialDataMap::const_iterator & | end
| ) |  | const
| protected

This method is a helper function for selectTest. It is used to test for selection when the chart style is csOhlc. It only tests against the data points between begin and end.

double QCPFinancial::candlestickSelectTest | ( | const QPointF & | pos,
|  | const QCPFinancialDataMap::const_iterator & | begin,
|  | const QCPFinancialDataMap::const_iterator & | end
| ) |  | const
| protected

This method is a helper function for selectTest. It is used to test for selection when the chart style is csCandlestick. It only tests against the data points between begin and end.

void QCPFinancial::getVisibleDataBounds | ( | QCPFinancialDataMap::const_iterator & | lower,
|  | QCPFinancialDataMap::const_iterator & | upper
| ) |  | const
| protected

called by the drawing methods to determine which data (key) range is visible at the current key axis range setting, so only that needs to be processed.

lower returns an iterator to the lowest data point that needs to be taken into account when plotting. Note that in order to get a clean plot all the way to the edge of the axis rect, lower may still be just outside the visible range.

upper returns an iterator to the highest data point. Same as before, upper may also lie just outside of the visible range.

if the plottable contains no data, both lower and upper point to constEnd.

See Also
  QCPGraph::getVisibleDataBounds

The documentation for this class was generated from the following files:

- src/plottables/plottable-financial.h
- src/plottables/plottable-financial.cpp